(ns rlm.clipboard
  (:import java.awt.datatransfer.Transferable)
  (:import java.awt.Toolkit)
  (:import sun.awt.X11.XClipboard)
  (:import java.awt.datatransfer.DataFlavor)
  (:use [clojure.contrib [duck-streams :only [file-str]]])
  (:use rlm.shell-inspect))

(import '(javax.imageio.stream FileImageOutputStream))
(import '(javax.imageio ImageWriteParam IIOImage))
(import '(javax.imageio ImageIO) )
(import '(java.io File) )

(def clip (.getSystemClipboard (Toolkit/getDefaultToolkit)))

(defn get-clipboard-image
  "if the clipboard has an image, return it"
  []
  (.getTransferData
   (.getContents
    (.getSystemClipboard
     (Toolkit/getDefaultToolkit)) nil)
   DataFlavor/imageFlavor))


(def *ext* "jpg")

(defn writeJpg
  "WTF is this shit?!"
  [image #^File target quality]
  (let [jpgWriter (.next (ImageIO/getImageWritersByFormatName *ext*))]
    (doto (.getDefaultWriteParam jpgWriter) 
      (.setCompressionMode ImageWriteParam/MODE_EXPLICIT)
      (.setCompressionQuality quality))
    (doto jpgWriter
      (.setOutput (FileImageOutputStream. target))
      (.write (IIOImage. image nil nil))
      (.dispose))))


(defn save-clipboard
  [target]
  (writeJpg
   (get-clipboard-image)
   (file-str target)
   1))

(def counter
  (let [count (atom 0)]
    (fn [] (swap! count inc)))) 


(defn clipsave []
  (save-clipboard (str "/home/r/Desktop/cedba/homo/" (counter) ".jpg")))


(if (command-line?) (clipsave))
  
