(ns rlm.general-export
  (:use coderloop.export-files)
  (:use clojure.java.io)
  (:use [clojure.contrib [duck-streams :only [file-str]]])
  (:use [rlm
	 [classpath-utils :only [classpath]]
	 [shell-write :only [sw]]])
  (:require clojure.string)
  (:import java.io.File)
  (:import [org.apache.commons.io FileUtils]))


;;(def *nailgun* true)
;;; put standard base-path on the classpath
(def *standard-base-directory* (file-str "~/.clojure-exports/"))


(defn clear-directory [dir]
  (FileUtils/forceMkdir standard-base-directory)
  (FileUtils/forceDelete standard-base-directory)
  (FileUtils/forceMkdir standard-base-directory))


(defn export-bzip [destination bzip-name namespace src lib]
  (clear-directory *standard-base-directory*)
  (let [new-dir
	(file-str
	 (str (.getCanonicalPath standard-base-directory)
	  (File/separatorChar) bzip-name ))]
    (export-dependencies namespace new-dir src lib)
    (make-run-script namespace new-dir bzip-name src lib)
    (bzip-export-files new-dir destination bzip-name ".tar.bz2" src lib)))

(defn export-eclipse [target-source-dir target-jar-dir clojure-jar-name namespace])
