(ns rlm.shell-write
  
  (:use
   [clojure.contrib
    [duck-streams :only [file-str]]
    command-line
    str-utils
    shell-out
    ])
  
  (:import (java.io File BufferedReader ByteArrayOutputStream InputStreamReader))
  (:import (org.apache.commons.exec PumpStreamHandler DefaultExecutor ExecuteWatchdog CommandLine)))


(defn sw 
  "same as sh but uses apache-commons to actually execute the process,
   and prints output as soon as the subprocess returns output. Prints all
   errors and normal ouput"
  [& commands+args]

  (let [[commands {:keys [dir]}] (split-with string? commands+args)]
    (let 
	[
	 parsed-commands (str (CommandLine/parse (apply str (interpose " " commands))))
	 process (if dir
		   (.exec (Runtime/getRuntime) parsed-commands
			  (into-array String "") (file-str dir))
		   (.exec (Runtime/getRuntime) parsed-commands))]
      (println parsed-commands)
      (let [reader 
	    (BufferedReader. 
	     (InputStreamReader. (.getInputStream process)))
	    
	    error-reader
	    (BufferedReader. 
	     (InputStreamReader. (.getErrorStream process)))]
      
					;output from program
      
	(loop []
	  (let [line (.readLine reader )]
	    (if (not (nil? line))
	      (do (println line) (recur)) nil)))
	
					;errors from program
	
	
	(let [err-str
	      
	      (loop [errors ""] 
		(let [line (.readLine error-reader )]
		  (if (not (nil? line))
		    (recur (str errors line "\n"))
		    errors)))]
	  (if (> (.length err-str) 0)
	    (do
	      (println "******************** Error Stream ********************")
	      (println err-str)
	      (println "******************************************************"))))))))

	    






     


