(ns rlm.twitter
  (:use [clojure.contrib.duck-streams :as ds :only []]
	[clojure.contrib.def :as def :only []]))
  
(def/defn-memo available-name? [user]
  (not
   (re-matches
    #".*has already been taken.*"
    (ds/slurp*
     (str "https://twitter.com/users/username_available?username=" user)))))

(def naturals (iterate inc 0))

(filter (comp not nil?)
	(pmap (fn [num] (if (available-name? num) num nil))
	      (apply vector (take 6000 naturals))))
